
  <!DOCTYPE html>
  <html>
    <head>
      <title>projects.ts</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/api/projects.ts</td><td class="">95.44%</td><td class="">80%</td><td class="">417</td><td class="">398</td><td class="">19</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import { get, patch, post, del } from &#x27;./methods&#x27;;
import { TargetRole, mapObjectToRows } from &#x27;../pages/projects&#x27;;
import { RequestWrapper } from &#x27;./requestWrapper&#x27;;
import {
  createErrorNotification,
  createInfoNotification,
  createSuccessNotification,
  NOTY_TIMEOUT
} from &#x27;../components/notifications&#x27;;
import {
  FitParameter,
  mapOutputRoleToInputRole,
  mapOutputTypeToInputType
} from &#x27;./projectSettings&#x27;;

export interface Project {
  columns_map: null | { [key in TargetRole]?: string };
  creating_step: string;
  date_created: string;
  date_modified: string;
  id: string;
  initial_data: string;
  name: string;
  type: &#x27;clone selection&#x27;;
  user: string;
}

export class ProjectsApi {
  static getAll: () =&gt; Promise&lt;RequestWrapper&lt;any&gt;&gt; = () =&gt;
    get(&#x27;projects&#x27;)
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred while getting the list of projects&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;projects get error&#x27;);
        }
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while getting the list of projects&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;projects get error&#x27;);
      });

  static getUsersProjects: () =&gt; Promise&lt;RequestWrapper&lt;Project[]&gt;&gt; = () =&gt;
    get&lt;Project[]&gt;(&#x27;projects/users-projects&#x27;)
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred while getting the list of projects&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;projects get error&#x27;);
        }
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while getting the list of projects&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;projects get error&#x27;);
      });

  static update = async (
    projectId: string | number,
    {
      initialFile,
      columnsMap,
      name,
      newFitParameters,
      deleteFitParameters
    }: {
      initialFile?: File;
      columnsMap?: { [key in TargetRole]?: string };
      name?: string;
      newFitParameters?: FitParameter[];
      deleteFitParameters?: string[];
    }
  ): Promise&lt;RequestWrapper&lt;Project&gt;&gt; =&gt; {
    const editProjectNoty = createInfoNotification({
      text: &#x27;The project is being updated&#x27;
    });
    editProjectNoty.show();
    let res;
    if (!initialFile) {
      res = await patch&lt;Project&gt;(`projects/${projectId}`, {
        columns_map: columnsMap,
        name
      })
        .then((res) =&gt; {
          if (res.status !== 200) {
            createErrorNotification({
              text: &#x27;An error occurred while editing project&#x27;,
              timeout: NOTY_TIMEOUT
            }).show();
            throw new Error(&#x27;project edit error&#x27;);
          }
          createSuccessNotification({
            text: &#x27;Project was successfully updated&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          return res;
        })
        .catch(() =&gt; {
          createErrorNotification({
            text: &#x27;An error occurred while editing project&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;project edit error&#x27;);
        })
        .finally(() =&gt; {
          setTimeout(() =&gt; editProjectNoty.close(), NOTY_TIMEOUT / 2);
        });
    } else {
      const myHeaders = new Headers();
      myHeaders.append(
        &#x27;Authorization&#x27;,
        `Bearer ${localStorage.getItem(&#x27;TOKEN&#x27;)}`
      );

      const formData = new FormData();
      formData.append(
        &#x27;initial_file&#x27;,
        initialFile as File,
        (initialFile as File).name
      );
      if (name) {
        formData.append(&#x27;name&#x27;, name);
      }

      const requestOptions = {
        method: &#x27;PATCH&#x27;,
        headers: myHeaders,
        body: formData,
        redirect: &#x27;follow&#x27; as const
      };
      res = await fetch(
        `${process.env.REACT_APP_BACKEND_URL}/api/v1/projects`,
        requestOptions
      )
        .then((res) =&gt; res.json())
        .then((res) =&gt; {
          if (res.status !== 200) {
            createErrorNotification({
              text: &#x27;An error occurred while editing project&#x27;,
              timeout: NOTY_TIMEOUT
            }).show();
            throw new Error(&#x27;projects edit error&#x27;);
          }
          createSuccessNotification({
            text: &#x27;Project was successfully updated&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          return res;
        })
        .catch(() =&gt; {
          createErrorNotification({
            text: &#x27;An error occurred while editing project&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;project edit error&#x27;);
        })
        .finally(() =&gt; {
          editProjectNoty.close();
        });
    }
    if (newFitParameters) {
      await post(
        &#x27;fit-parameters&#x27;,
        newFitParameters.map((param) =&gt; ({
          ...param,
          role: (mapOutputRoleToInputRole as any)[param.role],
          type: (mapOutputTypeToInputType as any)[param.type as any]
        }))
      );
    }
    if (deleteFitParameters) {
      await Promise.all(
        deleteFitParameters.map((deleteFitParameter) =&gt; {
          return del(`fit-parameter/${deleteFitParameter}`);
        })
      );
    }
    return res;
  };

  static create = ({
    initialFile,
    name,
    type
  }: {
    initialFile: File;
    name: string;
    type: &#x27;DIGITAL_TWIN&#x27; | &#x27;CLONE_SELECTION&#x27;;
  }): Promise&lt;RequestWrapper&lt;Project&gt;&gt; =&gt; {
    const createProjectNoty = createInfoNotification({
      text: &#x27;The project is being updated&#x27;
    });
    createProjectNoty.show();
    const myHeaders = new Headers();
    myHeaders.append(
      &#x27;Authorization&#x27;,
      `Bearer ${localStorage.getItem(&#x27;TOKEN&#x27;)}`
    );

    const formData = new FormData();
    formData.append(
      &#x27;initial_file&#x27;,
      initialFile as File,
      (initialFile as File).name
    );
    formData.append(&#x27;name&#x27;, name);
    formData.append(&#x27;type&#x27;, type);

    const requestOptions = {
      method: &#x27;POST&#x27;,
      headers: myHeaders,
      body: formData,
      redirect: &#x27;follow&#x27; as const
    };
    return fetch(
      `${process.env.REACT_APP_BACKEND_URL}/api/v1/projects`,
      requestOptions
    )
      .then((res) =&gt; res.json())
      .then((res) =&gt; {
        if (res.status !== 201) {
          createErrorNotification({
            text: &#x27;An error occurred while creating project&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;projects create error&#x27;);
        }
        createSuccessNotification({
          text: &#x27;Project was successfully updated&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while creating project&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;project create error&#x27;);
      })
      .finally(() =&gt; {
        setTimeout(() =&gt; createProjectNoty.close(), NOTY_TIMEOUT / 2);
      });
  };

  static getInitialData = (projectId: string | number) =&gt;
    get&lt;object[]&gt;(`projects/${projectId}/initial-data`)
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred while getting initial data&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;get initial data error&#x27;);
        }
        const rs = mapObjectToRows(res.data);
        return rs;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while getting initial data&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;get initial data error&#x27;);
      });

  static updateInitialData = (projectId: string | number, data: object) =&gt;
    patch(`projects/${projectId}/initial-data`, data);

  static fit = (projectId: string | number) =&gt; {
    const startFittingModelNoty = createInfoNotification({
      text: &#x27;The model rendering is being launched&#x27;
    });
    startFittingModelNoty.show();
    return post(`projects/${projectId}/fit`, {})
      .then((res) =&gt; {
        if (res.status !== 200) {
          createErrorNotification({
            text: &#x27;An error occurred while starting fitting model&#x27;,
            timeout: NOTY_TIMEOUT
          }).show();
          throw new Error(&#x27;start fitting error&#x27;);
        }
        createSuccessNotification({
          text: &#x27;The model rendering has been successfully launched&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        return res;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while starting fitting model&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        throw new Error(&#x27;start fitting error&#x27;);
      })
      .finally(() =&gt; {
        setTimeout(() =&gt; startFittingModelNoty.close(), NOTY_TIMEOUT / 2);
      });
  };

  static delete = (
    projectId: string | number
  ): Promise&lt;RequestWrapper&lt;any&gt;&gt; =&gt; {
    const deleteProjectNoty = createInfoNotification({
      text: &#x27;The model is being deleted&#x27;
    });
    deleteProjectNoty.show();
    return del(`projects/${projectId}`)
      .then((res) =&gt; {
        createSuccessNotification({
          text: &#x27;The project was successfully deleted&#x27;,
          timeout: NOTY_TIMEOUT
        }).show();
        return res;
      })
      .catch((res) =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while deleting project&#x27;,
          timeout: NOTY_TIMEOUT
        });
        throw new Error(&#x27;delete project error&#x27;);
      })
      .finally(() =&gt; {
        setTimeout(() =&gt; {
          deleteProjectNoty.close();
        }, NOTY_TIMEOUT / 2);
      });
  };

  static rendering = () =&gt; {
    return get&lt;string[]&gt;(&#x27;projects/rendering&#x27;)
      .then((res) =&gt; {
        return res.data;
      })
      .catch(() =&gt; {
        createErrorNotification({
          text: &#x27;An error occurred while getting rendering projects&#x27;,
          timeout: NOTY_TIMEOUT
        });
        throw new Error(&#x27;rendering project error&#x27;);
      });
  };
}
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:88,&quot;character&quot;:8,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:90,&quot;character&quot;:6,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:141,&quot;character&quot;:6,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:146,&quot;character&quot;:15,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:147,&quot;character&quot;:14,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:147,&quot;character&quot;:18,&quot;text&quot;:&quot;status&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:158,&quot;character&quot;:17,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:176,&quot;character&quot;:10,&quot;text&quot;:&quot;role&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:176,&quot;character&quot;:17,&quot;text&quot;:&quot;mapOutputRoleToInputRole as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:177,&quot;character&quot;:10,&quot;text&quot;:&quot;type&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:177,&quot;character&quot;:17,&quot;text&quot;:&quot;mapOutputTypeToInputType as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:177,&quot;character&quot;:50,&quot;text&quot;:&quot;param.type as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:230,&quot;character&quot;:13,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:231,&quot;character&quot;:12,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:231,&quot;character&quot;:16,&quot;text&quot;:&quot;status&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:242,&quot;character&quot;:15,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:320,&quot;character&quot;:13,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:325,&quot;character&quot;:15,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/api/projects.ts&quot;,&quot;line&quot;:327,&quot;character&quot;:14,&quot;text&quot;:&quot;res&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  